;
; rotating program example by Richard Nichols (tiberius). This source is
; submitted to the public domain. It may not be sold for profit or claimed
; as the work of another.
;
; other than that enjoy ! =) I wrote this late at night in about 15 minutes
; so things are fairly messy. You're here to see the application of math not
; how to code though =)
;
; The picture is drawn by me and was my first attempt at a hand drawn gfx...
;
; a lot of this assembler source is crap. I don't often write 100% asm which
; is why =) anyhow, check out gentrig.pas for the generation of the trig.dw
; file that is needed by this. The output is 16 bit fixed point result (no
; high bits because sin/cos are always between -1 and 1. Also this could be
; much faster with some optimization. I'm not gonna do that though.
; the picture displays twice as big due to the fixed point screw up (i think)
; which I didnt realise before I started writing and cant be bothered to
; fix now. the botton line: it works, learn from it.
;
; later! -tiberius (tiberius@mailhost.net)
;
; (compiles in tasm 3.2 and 5 i think =)

DOSSEG
.MODEL SMALL
.286
.STACK 200h

.DATA

endmessage db "Amazing wasn't it? - Tiberius/Inspire Media",13,10
           db "-------------------------------------------",13,10
           db "frames/sec:",13,10
           db "$"
endfps     db "00h",13,10,"$"

pafile db "marine.col",0
pifile db "marine.raw",0

INCLUDE trig.dw                         ; the file with the sinus/cosinus data

framecount dw 0                         ; to count the number of rendered frames
secondcount dw 0

hexchars db "0123456789ABCDEF"

angle dw 0                              ; these vars are the same as in the
nx dw ?                                 ; higher level versions of this prog
ny dw ?
tx dw ?
ty dw ?
ycos dw ?
xcos dw ?
ysin dw ?
xsin dw ?

oldtimerseg     dw ?
oldtimeroffset  dw ?

palette db 768 dup (?)
picture db 25521 dup (?)                ; picture is 181x141 pixels

.CODE

LoadData PROC 

        pusha
        mov ax, 3d00h                   ; who cares about error checking?
        mov bx, seg pifile
        mov ds, bx
        mov dx, offset pifile
        int 21h
        mov bx, seg picture
        mov ds, bx
        mov dx, offset picture
        mov bx, ax
        mov ax, 3f00h
        mov cx, 25521
        int 21h
        mov ax, 3e00h
        int 21h
        mov ax, 3d00h                   ; who cares about error checking?
        mov bx, seg pafile
        mov ds, bx
        mov dx, offset pafile
        int 21h
        mov bx, seg palette
        mov ds, bx
        mov dx, offset palette
        mov bx, ax
        mov ax, 3f00h
        mov cx, 768
        int 21h
        mov ax, 3e00h
        int 21h
        popa
        ret

LoadData ENDP

Initialise PROC 

        pusha
        mov ax, 13h                           ; change to graphics mode
        int 10h
        mov ax, 0a000h                        ; clear video memory
        mov es, ax
        xor di, di
        xor ax, ax
        mov cx, 32000
        rep stosw
        mov ax, seg palette
        mov ds, ax
        mov si, offset palette
        mov dx, 3c8h
        mov al, 0
        out dx, al
        inc dx
        mov cx, 768

paletteloop:                                  ; set the palette
        lodsb
        out dx, al
        loop paletteloop

        popa
        ret

Initialise ENDP

InstallTimer PROC 

        pusha
        mov ax, 3508h
        int 21h
        mov [oldtimerseg], es
        mov [oldtimeroffset], bx
        mov ax, 2508h
        push cs
        pop ds
        mov dx, offset newtimer
        int 21h
        popa
        ret

InstallTimer ENDP

NewTimer PROC 

        pusha

        add [secondcount], 1
        mov     al,20h
        out     20h,al

        popa
        iret

NewTimer ENDP

RotateUntilKey PROC 

        pusha
        mov ax, seg sin                 ; im gonna assume sin/cos in same ds
        mov ds, ax                      ; a bit dangerous but very helpful!
        mov ax, 0a000h
        mov es, ax

StartMainLoop:
        add [framecount], 1
        mov ax, [angle]
        cmp ax, 359
        jng SkipAngleChange
        sub [angle], 360
SkipAngleChange:
        mov di, 46                      ; first pixel to draw
        mov [ny], -99                     ; goes to 100        
mainyloop:
        mov [nx], -114                    ; goes to 115
mainxloop:
        mov si, offset cos
        add si, angle                   ; add angle*2
        add si, angle
        mov bx, ds:[si]
        mov ax, [nx]
        imul bx
        mov [xcos], dx                  ; we only want the high word
        mov ax, [ny]
        imul bx
        mov [ycos], dx
        mov si, offset sin              ; now onto sin
        add si, angle
        add si, angle
        mov bx, ds:[si]
        mov ax, [nx]
        imul bx
        mov [xsin], dx
        mov ax, [ny]
        imul bx
        mov [ysin], dx
        mov bx, [xcos]                  ; now we have everything : calc
        sub bx, [ysin]
        add bx, 90
        mov ax, [xsin]
        add ax, [ycos]
        add ax, 70
        cmp bx, 181
        jg  skipplot
        cmp bx, 0
        jl  skipplot
        cmp ax, 141
        jg  skipplot
        cmp ax, 0
        jl  skipplot
        push ds
        mov cx, seg picture                     ; get to picture byte
        mov ds, cx
        mov si, offset picture
        mov cl, 181
        mul cl
        add si, ax
        add si, bx       
        movsb
        pop ds
        dec di
skipplot:
        inc di
        add [nx], 1
        mov ax, [nx]
        cmp ax, 115
        jge mxlend
        jmp mainxloop
mxlend:
        add di, 91                              ; back to left dot
        add [ny], 1
        mov ax, [ny]
        cmp ax, 100
        jge mylend
        jmp mainyloop
mylend:

        add [angle], 2

        mov ax, 100h                    ; go until key pressed
        int 16h
        jnz stopit
        jmp startmainloop
stopit:
        popa
        ret

RotateUntilKey ENDP

KillTimer PROC 

        pusha
        mov dx, [oldtimeroffset]      ; if i set ds before dx
        mov ds, [oldtimerseg]         ; dx is set to wrong value! - why???
        mov ax, 2508h
        int 21h
        popa
        ret

KillTimer ENDP

Shutdown PROC 

        pusha
        xor ax, ax                              ; grab that key
        int 16h
        mov ax, 3h                              ; back to textmode
        int 10h
        mov ax, seg endmessage
        mov ds, ax
        mov dx, offset endmessage
        mov ax, 900h                            ; print a pointless message
        int 21h
        mov ax, [framecount]                    ; print fps
        mov bx, 18
        mul bx
        mov bx, [secondcount]
        div bx
        mov bx, ax
        mov ax, seg endfps
        mov es, ax
        mov di, offset endfps
        mov ax, seg hexchars
        mov ds, ax
        mov si, offset hexchars
        push si
        mov dx, bx
        shr dx, 8
        add si, dx
        movsb
        pop si
        mov dx, bx
        xor dh, dh
        add si, dx
        movsb
        mov ax, 900h
        push es
        pop ds
        mov dx, offset endfps
        int 21h
        popa
        ret

Shutdown ENDP


START:

  call LoadData                         ; load picture and palette
  call Initialise                       ; set palette and screen mode
  call InstallTimer                     ; install a int handler for frame rate
  call RotateUntilKey                   ; rotate until a key is pressed
  call KillTimer                        ; kills our timer
  call Shutdown                         ; duh!

  mov  ax, 4c00h                        ; back to friendly old dos
  int  21h

END START

